/*
 *	lockd		This is the main procedure of rpc.lockd.
 *
 *	Cyopright (C) 1995, Olaf Kirch <okir@monad.swb.de>
 *
 */

#include <stdio.h>
#include <signal.h>
#include "rpcdispatch.h"
#include "nlm.h"
#include "lklm.h"

static void dumplocks(int sig);
static void usage(void);

int		nlm_svcpg = NLM_PROG;
int		nlm_cltpg = NLM_PROG;

int
main(int argc, char **argv)
{
	int	debug_server = 0,
		debug_client = 0;
	int	c;

	while ((c = getopt(argc, argv, "SC")) != EOF) {
		switch (c) {
		case 'S':
			debug_server = 1;
			debug_client = 0;
			break;
		case 'C':
			debug_server = 0;
			debug_client = 1;
			break;
		default:
			fprintf(stderr, "rpc.lockd: unknown option -%c\n", c);
			usage();
		}
	}

	if (debug_client) {
		nlm_cltpg = NLM_PROG_DEBUG;
		nlm_register(NLM_PROG_DEBUG);
		lklm_register();
	} else if (debug_server) {
		nlm_cltpg = NLM_PROG_DEBUG;
		nlm_register(NLM_PROG);
	} else {
		nlm_register(NLM_PROG);
		lklm_register();
	}

	signal (SIGHUP, dumplocks);

	host_init();

	rpc_svcrun();
	log(L_FATAL, "Oook? svc_run returned.\n");
	return 2;
}

static void
usage(void)
{
	fprintf (stderr, "usage: rpc.lockd [-SC]\n");
	exit (2);
}

static void
dumplocks(int sig)
{
	static int	excl = 0;

	signal (SIGHUP, dumplocks);
	if (!excl) {
		excl = 1;
		lock_dump();
		excl = 0;
	}
}
