/*
 * proto.c	Provide the appropriate protocol handler for a given
 *		lock protocol.
 *
 */

#include "lock.h"
#include "file.h"
#include "host.h"
#include "lklm.h"
#include "nlm.h"

/*
 * Find the protocol handler given a LKLM protocol ID.
 * We currently support only NLM1-3.
 */
lockd_proto *
proto_find(int protno)
{
	lockd_proto	*prot = NULL;

	switch (protno) {
	case LKLM_PROT_NLM1:
		prot = &proto_nlm1;
		break;
	case LKLM_PROT_NLM4:
	default:
		log(L_ERROR, "lock protocol %d not supported");
	}

	return prot;
}
