/*
 * unfsfh.h	This module treats file handles issued by unfsd.
 *
 * Authors:	Mark A. Shand, May 1988
 *		Don Becker, <becker@super.org>
 *		Rick Sladkey, <jrs@world.std.com>
 *		Fred N. van Kempen, <waltje@uWalt.NL.Mugnet.ORG>
 *
 *		Copyright 1988 Mark A. Shand
 *		This software maybe be used for any purpose provided
 *		the above copyright notice is retained.  It is supplied
 *		as is, with no warranty expressed or implied.
 */

#include <linux/nfs.h>

#ifndef UNFSFH_H
#define UNFSFH_H

#define	HP_LEN			(NFS_FHSIZE - sizeof(unsigned long))

/*
 * Hashed search path to this file.
 * path is: hash_path[1] ... hash_path[hash_path[0]]
 *
 * hash_path[hash_path[0]+1] ... hash_path[HP_LEN-1] == 0
 */
typedef struct {
  u_long	psi;
  u_char	hash_path[HP_LEN];
} svc_fh;

char	*unfsfh_buildpath(struct nfs_fh *fhp);
int	unfsfh_buildfh(char *path, struct nfs_fh *fh);

#endif /* UNFSFH_H */
